#include "testlib.h"

using namespace std;

typedef long long ll;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), mode = opt<int>("mode");
    ll a = has_opt("a") ? opt<ll>("a") : 1000'000'000'000;
    double duo = has_opt("duo") ? opt<double>("duo") : 0.1;

    vector<pair<ll, ll>> rects;
    ll x = rnd.wnext(a / 2, a, 1), y = rnd.wnext(a / 2, a, 1);
    if (mode == 2) {
        rects.emplace_back(x, y);
    } else if (mode == 1) {
        rects.emplace_back(x, rnd.next(1ll, a));
    } else {
        rects.emplace_back(rnd.next(1ll, a), rnd.next(1ll, a));
    }
    for (int i = n - 1; i > 1; i--) {
        if (rnd.next() < duo &&
            (x % 2 == 0 && x / 2 + y > i || y % 2 == 0 && y / 2 + x > i)) {
            if (x % 2 != 0 || x / 2 + y <= i || (rnd.next(2) && y % 2 == 0 && y / 2 + x > i))
                swap(x, y);
            rects.emplace_back(x / 2, y);
            x /= 2;
        } else if (rnd.next(2) && x > 1 || y == 1) {
            ll dx = rnd.next(max(1ll, i - y + 1), x - 1);
            rects.emplace_back(x - dx, y);
            x = dx;
        } else {
            ll dy = rnd.next(max(1ll, i - x + 1), y - 1);
            rects.emplace_back(y - dy, x);
            y = dy;
        }
    }

    rects.emplace_back(x, y);
    reverse(rects.begin(), rects.end());

    println(n);
    for (auto &rect : rects) {
        if (rnd.next(2)) swap(rect.first, rect.second);
        println(rect.first, rect.second);
    }

}